# Flag variables
CXX=g++
CFLAGS=-Wall -g

# Bulid files folders
BUILD_DIR=build
PRES_DIR=$(BUILD_DIR)/pres
ASS_DIR:=$(BUILD_DIR)/assemblers
OBJ_DIR:=$(BUILD_DIR)/objs

# Get all files .cpp, .o, .s, .ii
SOURCES:=$(wildcard *.cpp)
PRES:=$(patsubst %.cpp, $(PRES_DIR)/%.ii, $(SOURCES))
ASS:=$(patsubst %.cpp, $(ASS_DIR)/%.s, $(SOURCES))
OBJS:=$(patsubst %.cpp, $(OBJ_DIR)/%.o, $(SOURCES))

# Dont delete prss and assmbler files
.PRECIOUS: $(ASS)
.PRECIOUS: $(PRES)

# Compile process
all: grades

# Compile o files
grades: $(OBJS)
	$(CXX) $(CFLAGS) $? -o $@

# Compile o files
$(OBJ_DIR)/%.o: $(ASS_DIR)/%.s
	$(CXX) $(CFLAGS) -c $< -o $@

# compile s files
$(ASS_DIR)/%.s: $(PRES_DIR)/%.ii
	$(CXX) -S $< -o $@

# compile ii files and create build diractory if has changes
$(PRES_DIR)/%.ii: %.cpp | $(BUILD_DIR)
	$(CXX) -E $< -o $@

# Build diractory
$(BUILD_DIR):
	mkdir $(BUILD_DIR) $(PRES_DIR) $(ASS_DIR) $(OBJ_DIR)

# Delete all
clean:
	rm -rf $(BUILD_DIR) grades
